

.text
.globl	string_len
.type	string_len, @function

string_len:
    # Fix up the stack frame
    # Give ourselves 16 bytes to work with
    pushl %ebp
    movl %esp, %ebp

    # Put the parameter (the base of a char[] (string) in %ecx)
    movl 8(%ebp), %ecx

    # Call the actual code
    jmp string_len_start

# Return from the function
function_return:
    pop %ebx
    movl %ebx, %ebp
    ret

################################################
# THIS IS THE ACTUAL DEFINITION HERE
#
# String length procedure
# parameter: A pointer to the start of a char[]
#            in %ecx
# return: the length of the string (how many chars befor '\0')
#         in %eax
#
################################################

string_len_start:

    # Check to be sure the input is not null
    cmpl $0, %ecx
    # If it is not 0, continue executing
    jne init_loop
    # If the input was 0 (NULL) set the return value to 0
    movl $0, %eax
    jmp function_return

init_loop:
    movl $0, %ebx          # Move 0 into the current length

# Here, we are going to iterate through the string, once we find a '\0' we
# will stop and return the length (via %eax)
while_loop:
    movzbl  (%ecx,%ebx), %eax   # Move (with 0 extension) the byte at in the
                                # %ebx location starting at the base of the
                                # array, held in %ecx
    testb   %al, %al            # Checks to see if %al (the low order byte in %eax)
                                # has any 1's, if not, ZF is set to 1
    je      return_value        # If it is 0, then set the return value
    addl    $1, %ebx            # Otherwise, Increment the length by 1
    jmp     while_loop          # Jump to the top of the loop

return_value:
    movl %ebx, %eax        # Put the return value (length) in %eax
    jmp function_return    # Return from the function
